it-swarm-fr.com

bash: imprimer stderr en couleur rouge

Existe-t-il un moyen de faire afficher bash stderr des messages de couleur rouge?

124
kolypto
command 2> >(while read line; do echo -e "\e[01;31m$line\e[0m" >&2; done)
103
Balázs Pozsár

Méthode 1: utilisez la substitution de processus:

command 2> >(sed $'s,.*,\e[31m&\e[m,'>&2)

Méthode 2: créer une fonction dans un script bash:

color()(set -o pipefail;"[email protected]" 2>&1>&3|sed $'s,.*,\e[31m&\e[m,'>&2)3>&1

Utilisez-le comme ceci:

$ color command

Les deux méthodes afficheront le stderr de la commande en rouge.

Continuez à lire pour une explication du fonctionnement de la méthode 2. Il y a quelques fonctionnalités intéressantes démontrées par cette commande.

  • color()... - Crée une fonction bash appelée couleur.
  • set -o pipefail - Il s'agit d'une option Shell qui préserve le code retour d'erreur d'une commande dont la sortie est redirigée vers une autre commande. Cela se fait dans un sous-shell, qui est créé par les parenthèses, afin de ne pas modifier l'option pipefail dans le shell externe.
  • "[email protected]" - Exécute les arguments de la fonction comme une nouvelle commande. "[email protected]" Est équivalent à "$1" "$2" ...
  • 2>&1 - Redirige le stderr de la commande vers stdout pour qu'il devienne sed's stdin.
  • >&3 - Raccourci pour 1>&3, Ceci redirige stdout vers un nouveau descripteur de fichier temporaire 3. 3 Est réacheminé vers stdout plus tard.
  • sed ... - En raison des redirections ci-dessus, sed est stdin est le stderr de la commande exécutée. Sa fonction est d'entourer chaque ligne de codes couleur.
  • $'...' Une construction bash qui lui fait comprendre les caractères échappés par une barre oblique inverse
  • .* - Correspond à toute la ligne.
  • \e[31m - La séquence d'échappement ANSI qui provoque le rouge des caractères suivants
  • & - Le caractère de remplacement de sed qui s'étend à toute la chaîne correspondante (la ligne entière dans ce cas).
  • \e[m - La séquence d'échappement ANSI qui réinitialise la couleur.
  • >&2 - Raccourci pour 1>&2, Ceci redirige sed de stdout vers stderr.
  • 3>&1 - Redirige le descripteur de fichier temporaire 3 Vers stdout.
93
killdash9

Vous pouvez également consulter stderred: https://github.com/sickill/stderred

29
sickill

La manière bash de rendre stderr rouge en permanence est d'utiliser 'exec' pour rediriger les flux. Ajoutez ce qui suit à votre bashrc:

exec 9>&2
exec 8> >(
    while IFS='' read -r line || [ -n "$line" ]; do
       echo -e "\033[31m${line}\033[0m"
    done
)
function undirect(){ exec 2>&9; }
function redirect(){ exec 2>&8; }
trap "redirect;" DEBUG
Prompt_COMMAND='undirect;'

J'ai posté à ce sujet précédemment: Comment définir la couleur de police pour STDOUT et STDERR

17
gospes
14
quaie

J'ai fait un script wrapper qui implémente la réponse de Balázs Pozsár en bash pur. Enregistrez-le dans vos commandes $ PATH et prefix pour coloriser leur sortie.

 
 #!/bin/bash 
 
 si [$ 1 == "--help"]; puis 
 echo "Exécute une commande et colorise toutes les erreurs survenues" 
 echo "Exemple:` nom de base $ {0} `wget ..." 
 echo "(c) o_O Tync , ICQ # 1227-700, Enjoy! "
 Exit 0 
 Fi 
 
 # Fichier Temp pour intercepter toutes les erreurs 
 TMP_ERRS = $ (mktemp ) 
 
 # Exécuter la commande 
 "$ @" 2>> (pendant la lecture de la ligne; faire echo -e "\ e [01; 31m $ line\e [0m" | tee --append $ TMP_ERRS; done) 
 EXIT_CODE = $? 
 
 # Affiche à nouveau toutes les erreurs 
 if [-s "$ TMP_ERRS"]; puis 
 echo -e "\ n\n\n\e [01; 31m === ERREURS ===\e [0m" 
 cat $ TMP_ERRS 
 fi 
 rm -f $ TMP_ERRS 
 
 # Terminer 
 quitter $ EXIT_CODE 
 
7
kolypto

Vous pouvez utiliser une fonction comme celle-ci


 #!/bin/sh

color() {
      printf '\033[%sm%s\033[m\n' "[email protected]"
      # usage color "31;5" "string"
      # 0 default
      # 5 blink, 1 strong, 4 underlined
      # fg: 31 red,  32 green, 33 yellow, 34 blue, 35 purple, 36 cyan, 37 white
      # bg: 40 black, 41 red, 44 blue, 45 purple
      }
string="Hello world!"
color '31;1' "$string" >&2
</code>

J'ajoute> & 2 pour imprimer sur stderr

3
Ali Mezgani

Cette solution a fonctionné pour moi: https://superuser.com/questions/28869/immediately-tell-which-output-was-sent-to-stderr

J'ai mis cette fonction dans mon .bashrc ou .zshrc:

# Red STDERR
# rse <command string>
function rse()
{
    # We need to wrap each phrase of the command in quotes to preserve arguments that contain whitespace
    # Execute the command, swap STDOUT and STDERR, colour STDOUT, swap back
    ((eval $(for phrase in "[email protected]"; do echo -n "'$phrase' "; done)) 3>&1 1>&2 2>&3 | sed -e "s/^\(.*\)$/$(echo -en \\033)[31;1m\1$(echo -en \\033)[0m/") 3>&1 1>&2 2>&3
}

Alors par exemple:

$ rse cat non_existing_file.txt

me donnera une sortie rouge.

1
Eyal Levin

en utilisant xargs et printf:

command 2> >(xargs -0 printf "\e[31m%s\e[m" >&2)
1
Carlos Barcellos

J'ai une version légèrement modifiée du script d'O_o Tync. J'avais besoin de faire ces mods pour OS X Lion et ce n'est pas parfait car le script se termine parfois avant la commande encapsulée. J'ai ajouté un sommeil mais je suis sûr qu'il y a une meilleure façon.

#!/bin/bash

   if [ $1 == "--help" ] ; then
       echo "Executes a command and colorizes all errors occured"
       echo "Example: `basename ${0}` wget ..."
       echo "(c) o_O Tync, ICQ# 1227-700, Enjoy!"
       exit 0
       fi

   # Temp file to catch all errors
   TMP_ERRS=`mktemp /tmp/temperr.XXXXXX` || exit 1

   # Execute command
   "[email protected]" 2> >(while read line; do echo -e "$(tput setaf 1)$line\n" | tee -a $TMP_ERRS; done)
   EXIT_CODE=$?

   sleep 1
   # Display all errors again
   if [ -s "$TMP_ERRS" ] ; then
       echo -e "\n\n\n$(tput setaf 1) === ERRORS === "
       cat $TMP_ERRS
   else
       echo "No errors collected in $TMP_ERRS"
   fi
   rm -f $TMP_ERRS

   # Finish
   exit $EXIT_CODE
1
Cliff

une version utilisant fifos

mkfifo errs
stdbuf -o0 -e0 -i0 grep . foo | while read line; do echo -e "\e[01;31m$line  \e[0m" >&2; done &
stdbuf -o0 -e0 -i0 sh $script 2>errs
0
untore